package coffee;

import java.sql.BatchUpdateException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class CoffeeBatchInsert {
  public static void main(String args[]) {
    String url = "jdbc:mysql://localhost:3306/jdbcTest";
    Connection con;
    Statement stmt;

    try {
      Class.forName("com.mysql.jdbc.Driver");
    } catch (java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }

    try {
      con = DriverManager.getConnection(url, "root", "root");
      stmt = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
          ResultSet.CONCUR_UPDATABLE);
      con.setAutoCommit(false);
      stmt.addBatch("DELETE FROM COFFEES");
      stmt.addBatch("INSERT INTO COFFEES "
          + "VALUES(1,'Amaretto', 49, 9.99, 0, 0)");
      stmt.addBatch("INSERT INTO COFFEES "
          + "VALUES(2,'Hazelnut', 49, 9.99, 0, 0)");
      stmt.addBatch("INSERT INTO COFFEES "
          + "VALUES(3,'Amaretto_decaf', 49, 10.99, 0, 0)");
      stmt.addBatch("INSERT INTO COFFEES "
          + "VALUES(4,'Hazelnut_decaf', 49, 10.99, 0, 0)");
      stmt.executeBatch();
      con.setAutoCommit(true);
      ResultSet uprs = stmt.executeQuery("SELECT * FROM COFFEES");
      System.out.println("Table COFFEES after insertion:");

      while (uprs.next()) {
        String name = uprs.getString("COF_NAME");
        int id = uprs.getInt("SUP_ID");
        float price = uprs.getFloat("PRICE");
        int sales = uprs.getInt("SALES");
        int total = uprs.getInt("TOTAL");
        System.out.print(name + " " + id + " " + price);
        System.out.println(" " + sales + " " + total);
      }
      uprs.close();
      stmt.close();
      con.close();

    } catch (BatchUpdateException b) {
      System.err.println("SQLException: " + b.getMessage());
      System.err.println("SQLState: " + b.getSQLState());
      System.err.println("Message: " + b.getMessage());
      System.err.println("Vendor: " + b.getErrorCode());
      System.err.print("Update counts: ");
      int[] updateCounts = b.getUpdateCounts();
      for (int i = 0; i < updateCounts.length; i++) {
        System.err.print(updateCounts[i] + " ");
      }

    } catch (SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
      System.err.println("SQLState: " + ex.getSQLState());
      System.err.println("Message: " + ex.getMessage());
      System.err.println("Vendor: " + ex.getErrorCode());
    }
  }
}
